#include <esp_now.h>
#include <WiFi.h>

// Structure example to receive data
// Must match the sender structure
typedef struct struct_message {
  int stickX1;
  int stickY1;
  int stickB1;
  
  int stickX2;
  int stickY2;
  int stickB2;
  
  int stickX3;
  int stickY3;
  int stickB3;    
} struct_message;

// Create a struct_message called myData
struct_message myData;

// callback function that will be executed when data is received
void OnDataRecv(const uint8_t *macAddress, const uint8_t *incomingData, int len) {
  digitalWrite(LED_BUILTIN, HIGH);
  memcpy(&myData, incomingData, sizeof(myData));
  Serial.print("Bytes received: ");
  Serial.print(len);
  
  Serial.print(" X1: ");
  Serial.print(myData.stickX1);
  Serial.print(" Y1: ");
  Serial.print(myData.stickY1);
  Serial.print(" B1: ");
  Serial.print(myData.stickB1);
  
  Serial.print(" X2: ");
  Serial.print(myData.stickX2);
  Serial.print(" Y2: ");
  Serial.print(myData.stickY2);
  Serial.print(" B2: ");
  Serial.print(myData.stickB2);
  
  Serial.print(" X3: ");
  Serial.print(myData.stickX3);
  Serial.print(" Y3: ");
  Serial.print(myData.stickY3);
  Serial.print(" B3: ");
  Serial.println(myData.stickB3);
}

void setup() {
  pinMode(LED_BUILTIN, OUTPUT);
  
  Serial.begin(115200);

  // Set device as a Wi-Fi Station
  WiFi.mode(WIFI_STA);

  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }
  
  if (esp_now_register_recv_cb(OnDataRecv) != ESP_OK) {
    Serial.println("Error registering receive callback");
    digitalWrite(LED_BUILTIN, LOW);
    return;
  }

  // Register callback function to handle received data
  esp_now_register_recv_cb(OnDataRecv);
}

// unused
void loop() {
}
